package me.km.commands;

import me.kt.KajetansTools;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.playerbank.PlayerBank;
import java.util.UUID;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandBed extends ModuleCommand
{
    public CommandBed(Module m) 
    {
        super("bed", m);
        this.setDescription("Teleportiert einen Spieler zu einem Bett");
        this.setUsage("/bed [player]");
        this.setPermission("kt.bed");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(!(cs instanceof Player))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        Player p = (Player) cs;
        
        Location l; 
        if(arg.length == 0 || !p.hasPermission("kt.bed.other"))
        {
            l = p.getBedSpawnLocation();
            if(l == null)
            {
                this.getModule().send(cs, "Du hast keinen Bettspawn gesetzt.");
                return true;
            }
            p.teleport(l.add(1.5, 0.57, 1.5));
            this.getModule().send(cs, "Du wurdest zu deinem Bett teleportiert.");
            return true;
        }

        String uuid = KajetansTools.playerbank.getDataBank(PlayerBank.class).getUUID(arg[0]);
        if(uuid == null)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        OfflinePlayer affectedPlayer = Bukkit.getOfflinePlayer(UUID.fromString(uuid));  
        l = affectedPlayer.getBedSpawnLocation();
        if(l == null)
        {
            this.getModule().send(cs, affectedPlayer.getName() + " hat keinen Bettspawn gesetzt.");
            return true;
        } 
        p.teleport(l.add(1.5, 0.57, 1.5));
        this.getModule().send(cs, "Du wurdest zum Bett von " + affectedPlayer.getName() + " teleportiert.");
        return true;
    }
}
