package me.km.commands;

import me.kt.api.Utils;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.chatmanager.ChatManager;
import org.bukkit.Material;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.BookMeta;

public class CommandBook extends ModuleCommand
{
    public CommandBook(Module m) 
    {
        super("book", m);
        this.setDescription("Diverse Befehle für Bücher");
        this.setUsage("/book für die Hilfe");
        this.setPermission("kt.book");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(!(cs instanceof Player))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        Module m = this.getModule();
        Player p = (Player) cs;
        
        if(arg.length >= 1)
        {
            ItemStack stack = p.getInventory().getItemInMainHand();
            if(stack.getType() != Material.WRITTEN_BOOK)
            {
                m.send(cs, "Du hast kein signiertes Buch in der Hand.");
                return true;
            }
            BookMeta bmeta = (BookMeta) stack.getItemMeta();
            
            switch(arg[0])
            {
                case "open":
                {
                    ItemStack newItem = new ItemStack(Material.BOOK_AND_QUILL, stack.getAmount());
                    newItem.setItemMeta(bmeta);
                    p.getInventory().setItemInMainHand(newItem);
                    return true;
                }
                case "author":
                {       
                    bmeta.setAuthor(ChatManager.colorMessage(Utils.connectSpaces(arg, 1), p));
                    p.getInventory().getItemInMainHand().setItemMeta(bmeta);
                    p.updateInventory();
                    return true;
                }
                case "title":
                {       
                    bmeta.setTitle(ChatManager.colorMessage(Utils.connectSpaces(arg, 1), p));
                    p.getInventory().getItemInMainHand().setItemMeta(bmeta);
                    p.updateInventory();
                    return true;
                }
            }
        }
        
        m.send(cs, "/book ...");
        m.sendHelpListElement(cs, "open", "Öffnet dein Buch erneut");
        m.sendHelpListElement(cs, "author <name>", "Setzt den Autor des Buches");    
        m.sendHelpListElement(cs, "title <name>", "Setzt den Titel des Buches");    
        return true;
    }
}
