package me.km.commands;

import me.kt.api.Utils;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.exceptions.PlayerNotFoundException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandFeed extends ModuleCommand
{
    public CommandFeed(Module m) 
    {
        super("feed", m);
        this.setDescription("Sättigt den Hunger eines Spielers");
        this.setUsage("/feed [player]");
        this.setPermission("kt.feed");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        Player affectedPlayer;
        Module m = this.getModule();
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
            m.send(cs, "Der Hunger von " + affectedPlayer.getName() + " wurde gesättigt.");
            m.send(affectedPlayer, "Dein Hunger wurde gesättigt.");
        }
        catch(PlayerNotFoundException ex)
        {
            m.send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof Player))
            {
                m.send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (Player) cs;
            m.send(affectedPlayer, "Dein Hunger wurde gesättigt.");
        }
        affectedPlayer.setFoodLevel(20);
        affectedPlayer.setExhaustion(16);
        affectedPlayer.setSaturation(16);
        return true;
    }
}
