package me.km.commands;

import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.nms.NmsUtilities;
import org.bukkit.Material;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

public class CommandItemInfo extends ModuleCommand
{
    public CommandItemInfo(Module m) 
    {
        super("iteminfo", m);
        this.setDescription("Gibt Information über ein Item aus");
        this.setUsage("/iteminfo");
        this.setPermission("kt.iteminfo");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(!(cs instanceof Player))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        Module m = this.getModule();
        Player p = (Player) cs;
        ItemStack stack = p.getInventory().getItemInMainHand();
        if(stack == null || stack.getType() == Material.AIR)
        {
            m.send(cs, "Du musst ein Item in der Hand halten.");
            return true;
        }
        cs.sendMessage(GlobalText.Spacer());
        m.send(cs, "DV: §6" + stack.getDurability());
        m.send(cs, "Spigotname: §6" + stack.getType().toString().toLowerCase());
        m.send(cs, "Mojangname: §6" + NmsUtilities.getStackType(stack));
        try
        {
            m.send(cs, "Meta: §6" + stack.getItemMeta().toString());
        }
        catch(java.lang.NullPointerException ex)
        {
            m.send(cs, "Meta: §cFehler beim Lesen");
        }
        NmsUtilities.sendCopyableText(p, NmsUtilities.getNbtString(stack).replace("\"", "'"));
        return true;
    }
}
