package me.km.commands;

import me.kt.api.Utils;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.chatmanager.ChatManager;
import me.kt.exceptions.PlayerNotFoundException;
import java.util.HashMap;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandMsg extends ModuleCommand
{
    private final HashMap<String, String> answer; 
    
    public CommandMsg(Module m) 
    {
        super("msg", m);
        this.setDescription("Schreibt dem Spieler eine Privatnachricht");
        this.setUsage("/msg <player> <message> oder /r <message>");
        this.setPermission("kt.msg");
        
        answer = new HashMap<>();
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(!string.equalsIgnoreCase("r"))
        {
            if(arg.length <= 1)
            {
                return false;
            }
            Player affectedPlayer;
            try
            {
                affectedPlayer = Utils.getPlayerByName(arg[0]);                   
            }
            catch(PlayerNotFoundException ex)
            {
                this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
                return true;
            }
            String message = ChatManager.colorMessage(Utils.connectSpaces(arg, 1), cs);
            cs.sendMessage("§6[ -> §c" + affectedPlayer.getName() + "§6] §r" + message);
            affectedPlayer.sendMessage("§6[§c" + cs.getName()+ "§6] §r" + message);
            answer.put(cs.getName(), affectedPlayer.getName());
            answer.put(affectedPlayer.getName(), cs.getName());
            return true;
        }
        if(arg.length == 0)
        {
            return false;
        }
        String s = answer.get(cs.getName());
        if(s == null)
        {
            this.getModule().send(cs, "Du hast niemanden, dem du antworten könntest.");
            return true;
        }
        CommandSender previous;
        if(s.equals("CONSOLE"))
        {
            previous = Bukkit.getConsoleSender();
        }
        else
        {
            try
            {
                previous = Utils.getPlayerByName(s);            
            }
            catch(PlayerNotFoundException ex)
            {
                this.getModule().send(cs, "Du hast niemanden, dem du antworten könntest.");
                return true;
            }
        }
        
        String message = ChatManager.colorMessage(Utils.connectSpaces(arg, 0), cs);
        cs.sendMessage("§6[ -> §c" + previous.getName()+ "§6] §r" + message);
        previous.sendMessage("§6[§c" + cs.getName()+ "§6] §r" + message);
        answer.put(cs.getName(), previous.getName());
        answer.put(previous.getName(), cs.getName());
        return true;  
    }
}
