package me.km.commands;

import me.kt.KajetansTools;
import me.kt.api.Utils;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.playerbank.PlayerBank;
import me.kt.exceptions.PlayerNotFoundException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.UUID;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandSeen extends ModuleCommand
{
    public CommandSeen(Module m) 
    {
        super("seen", m);
        this.setDescription("Zeigt wann ein Spieler zuletzt online war");
        this.setUsage("/seen <player>");
        this.setPermission("kt.seen");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        try
        {
            Player p = Utils.getPlayerByName(arg[0]);  
            this.getModule().send(cs, p.getName() + " ist gerade online.");
            return true;
        }
        catch(PlayerNotFoundException ex)
        {
            String uuid = KajetansTools.playerbank.getDataBank(PlayerBank.class).getUUID(arg[0]);
            if(uuid == null)
            {
                this.getModule().send(cs, arg[0] + " war noch nie auf dem Server.");
                return true;
            }
            OfflinePlayer offPlayer = Bukkit.getOfflinePlayer(UUID.fromString(uuid));           
            Date date = new Date(offPlayer.getLastPlayed());
            SimpleDateFormat ft = new SimpleDateFormat ("dd.MM.yyyy 'um' HH:mm:ss");
            this.getModule().send(cs, arg[0] + " war zuletzt am " + ft.format(date) + " online.");
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }
}
