package me.km.commands;

import me.kt.api.Utils;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.exceptions.PlayerNotFoundException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandSpeed extends ModuleCommand
{
    public CommandSpeed(Module m) 
    {
        super("speed", m);
        this.setDescription("Setzt das Tempo eines Spielers");
        this.setUsage("/speed <1-10> [player]");
        this.setPermission("kt.speed");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(arg.length == 0)
        {
            return false;
        }
        
        int i;
        try
        {
            i = Integer.parseInt(arg[0]);
            if(i < 1)
            {
                throw new NumberFormatException();
            }
        }
        catch(NumberFormatException ex)
        {
            this.getModule().send(cs, GlobalText.noPositiveNaturalNumber());
            return true;
        }        
        if(i > 10)
        {
            i = 10;
        }     
        float f = i / 20f;
        
        Player affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[1]);  
            affectedPlayer.setFlySpeed(f);
            affectedPlayer.setWalkSpeed(f * 2);
            this.getModule().send(affectedPlayer, "Du hast nun Tempo " + i + ".");
            this.getModule().send(cs, affectedPlayer.getName() + " hat nun Tempo " + i + ".");
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[1]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof Player))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (Player) cs;
            affectedPlayer.setFlySpeed(f);
            affectedPlayer.setWalkSpeed(f * 2);
            this.getModule().send(affectedPlayer, "Du hast nun Tempo " + i + ".");
        } 
        return true;
    }
}
