package me.km.commands;

import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import java.util.HashMap;
import java.util.UUID;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandTeleportAccept extends ModuleCommand
{
    public HashMap<UUID, UUID> tpaccept;
    
    public CommandTeleportAccept(Module m) 
    {
        super("teleportaccept", m);
        this.setDescription("Akzeptiert eine Teleportanfrage");
        this.setUsage("/teleportaccept");
        this.setPermission("kt.teleportaccept");
        
        tpaccept = new HashMap<>();
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(!(cs instanceof Player))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        Player p = (Player) cs;
        if(!tpaccept.containsKey(p.getUniqueId()))
        {
            this.getModule().send(cs, "Du hast keine ausstehenden Teleportanfragen.");
            return true;
        }
        Player affectedPlayer = Bukkit.getPlayer(tpaccept.get(p.getUniqueId()));
        if(affectedPlayer == null)
        {
            this.getModule().send(cs, "Der Spieler ist nicht mehr online.");
            tpaccept.remove(p.getUniqueId());
            return true;
        }            
        tpaccept.remove(p.getUniqueId());
        affectedPlayer.teleport(p);
        this.getModule().send(affectedPlayer, "Du wurdest zu " + p.getName() + " teleportiert.");
        this.getModule().send(p, affectedPlayer.getName() + " hat sich zu dir teleportiert.");
        return true;
    }
}
