package me.km.commands;

import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandTime extends ModuleCommand
{
    public CommandTime(Module m) 
    {
        super("time", m);
        this.setDescription("Setzt die Tageszeit in einer Welt");
        this.setUsage("/time <day|night|ticks_as_number> [world]");
        this.setPermission("kt.time");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(arg.length == 0)
        {
            return false;
        }
        
        World w;
        if(arg.length < 2)
        {
            if(cs instanceof Player)
            {
                w = ((Player) cs).getWorld();
            }
            else
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }
        }
        else
        {
            w = Bukkit.getWorld(arg[1]);
            if(w == null)
            {
                this.getModule().send(cs, "Die angegebene Welt wurde nicht gefunden.");
                return true;
            }
        }
        
        if(arg[0].equals("day"))
        {
            w.setTime(0);
            this.getModule().send(cs, "Die Tageszeit wurde auf 0 gesetzt.");
            return true;
        }
        else if(arg[0].equals("night"))
        {
            w.setTime(14000);
            this.getModule().send(cs, "Die Tageszeit wurde auf 14000 gesetzt.");
            return true;
        }
        try
        {
            int time = Integer.parseInt(arg[0]);
            if(time < 0)
            {
                this.getModule().send(cs, GlobalText.noNaturalNumber());
                return true;
            }
            w.setTime(time);
            this.getModule().send(cs, "Die Tageszeit wurde auf " + arg[0] + " gesetzt.");
            return true;
        }
        catch(Exception ex)
        {
            this.getModule().send(cs, GlobalText.noNaturalNumber());
            return true;
        }
    }
}
