package me.km.commands;

import me.kt.api.Utils;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.playerbank.PlayerBank;
import me.kt.exceptions.PlayerNotFoundException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandTop extends ModuleCommand
{
    public CommandTop(Module m) 
    {
        super("top", m);
        this.setDescription("Teleportiert einen Spieler nach oben");
        this.setUsage("/top [player]");
        this.setPermission("kt.top");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        Player affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]); 
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof Player))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (Player) cs;
        }
        affectedPlayer.teleport(affectedPlayer.getWorld().getHighestBlockAt(affectedPlayer.getLocation()).getLocation().add(0.5, 0, 0.5));
        this.getModule().send(cs, "Du wurdest nach oben teleportiert.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " wurde nach oben teleportiert.");
        }
        return true;
    }
}
