package me.km.commands;

import me.kt.KajetansTools;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandUser extends ModuleCommand
{
    public CommandUser(Module m) 
    {
        super("user", m);
        this.setDescription("Gibt Informationen über einen Spieler");
        this.setUsage("/user <name>");
        this.setPermission("kt.user");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(arg.length < 1)
        {
            return false;
        }
        
        Module m = this.getModule();
        OfflinePlayer op = KajetansTools.playerbank.getDataBank().getOfflinePlayer(arg[0]);
        if(op == null)
        {
            m.send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        
        cs.sendMessage(GlobalText.Spacer());
        m.send(cs, op.getName());
        m.sendHelpListElement(cs, "UUID", op.getUniqueId().toString());
        m.sendHelpListElement(cs, "Gebannt", String.valueOf(op.isBanned()));
        m.sendHelpListElement(cs, "Whitelisted", String.valueOf(op.isWhitelisted()));
        if(op.isOnline())
        {
            Player p = op.getPlayer();
            m.sendHelpListElement(cs, "IP", p.getAddress().getAddress().toString().substring(1));
        }
        return true;
    }
}
