package me.km.commands;

import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.api.SimpleConfig;
import me.kt.api.Utils;
import me.kt.exceptions.PlayerNotFoundException;
import java.util.List;
import java.util.stream.Collectors;
import org.bukkit.Location;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandWarp extends ModuleCommand
{
    public CommandWarp(Module m) 
    {
        super("warp", m);
        this.setDescription("Teleportiert einen Spieler zum Warp");
        this.setUsage("/warp <warpname> [player]");
        this.setPermission("kt.warp");
    }

    public List<String> getWarps()
    {
        return SimpleConfig.getFiles("warp").stream().map(w -> w.getName().replace(".yml", "")).collect(Collectors.toList());
    }
    
    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(arg.length < 1)
        {
            this.getModule().send(cs, "Die folgenden Warps stehen zur Verfügung:");
            this.getModule().send(cs, String.join("§7, §r", getWarps()));   
            return true;
        }
        
        Location l = Utils.getWarp(arg[0]);
        if(l == null)
        {
            this.getModule().send(cs, "Der Warp existiert nicht bzw. seine Welt.");
            return true;
        }
        
        Player affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[1]);    
            affectedPlayer.teleport(l);
            this.getModule().send(affectedPlayer, "Du wurdest zum Warp " + arg[0] + " teleportiert.");
            this.getModule().send(cs, affectedPlayer.getName() + " wurde zum Warp " + arg[0] + " teleportiert.");
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[1]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof Player))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (Player) cs;
            affectedPlayer.teleport(l);
            this.getModule().send(cs, "Du wurdest zum Warp " + arg[0] + " teleportiert.");
        }
        return true;
    }
}
